diff --git a/src/gui/PlaylistWidget.hpp b/src/gui/PlaylistWidget.hpp
index 1f20e523..dfbd11c1 100644
--- a/src/gui/PlaylistWidget.hpp
+++ b/src/gui/PlaylistWidget.hpp
@@ -34,7 +34,7 @@ class QTreeWidgetItem;
 class PlaylistWidget;
 class Demuxer;
 
-class UpdateEntryThr final : public QThread
+class UpdateEntryThr : public QThread
 {
     Q_OBJECT
 
@@ -51,7 +51,7 @@ public:
     }
 
 private:
-    void run() override;
+    void run() override final;
 
     QAtomicInt pendingUpdates;
     IOController<> ioCtrl;
@@ -84,7 +84,7 @@ private slots:
     void finished();
 };
 
-class AddThr final : public QThread
+class AddThr : public QThread
 {
     Q_OBJECT
 public:
@@ -101,7 +101,7 @@ private slots:
     void modifyItemFlags(QTreeWidgetItem *tWI, int flags);
     void deleteTreeWidgetItem(QTreeWidgetItem *tWI);
 private:
-    void run() override;
+    void run() override final;
 
     bool add(const QStringList &urls, QTreeWidgetItem *parent, const Functions::DemuxersInfo &demuxersInfo, QStringList *existingEntries = nullptr, bool loadList = false);
     QTreeWidgetItem *insertPlaylistEntries(const Playlist::Entries &entries, QTreeWidgetItem *parent, const Functions::DemuxersInfo &demuxersInfo, int insertChildAt, QStringList *existingEntries);
@@ -120,7 +120,7 @@ signals:
     void status(bool s);
 };
 
-class PlaylistWidget final : public QTreeWidget
+class PlaylistWidget : public QTreeWidget
 {
     friend class AddThr;
     friend class UpdateEntryThr;
@@ -194,14 +194,12 @@ private:
 
     void quickSyncScanDirs(const QString &pth, QTreeWidgetItem *par, bool &mustRefresh, bool recursive, QTreeWidgetItem *&itemToNull);
 
-    void createExtensionsMenu();
-
-    void mouseMoveEvent(QMouseEvent *) override;
-    void dragEnterEvent(QDragEnterEvent *) override;
-    void dragMoveEvent(QDragMoveEvent *) override;
-    void dropEvent(QDropEvent *) override;
-    void paintEvent(QPaintEvent *) override;
-    void scrollContentsBy(int dx, int dy) override;
+    void mouseMoveEvent(QMouseEvent *) override final;
+    void dragEnterEvent(QDragEnterEvent *) override final;
+    void dragMoveEvent(QDragMoveEvent *) override final;
+    void dropEvent(QDropEvent *) override final;
+    void paintEvent(QPaintEvent *) override final;
+    void scrollContentsBy(int dx, int dy) override final;
 
     QRect getArcRect(int size);
 
@@ -226,8 +224,10 @@ private slots:
     void addTimerElapsed();
 public slots:
     void modifyMenu();
+    void createExtensionsMenu();
 signals:
     void returnItem(QTreeWidgetItem *);
     void visibleItemsCount(int);
     void addStatus(bool s);
+    void aboutToShow();
 };
diff --git a/src/gui/SettingsWidget.cpp b/src/gui/SettingsWidget.cpp
index d5b5a702..32809a17 100644
--- a/src/gui/SettingsWidget.cpp
+++ b/src/gui/SettingsWidget.cpp
@@ -26,7 +26,7 @@
 #include <Notifies.hpp>
 #include <Main.hpp>
 
-#include <QStandardPaths>
+#include <QDesktopServices>
 #include <QStyleFactory>
 #include <QRadioButton>
 #include <QApplication>
@@ -55,6 +55,8 @@
 #include <MenuBar.hpp>
 #include <Module.hpp>
 
+#include <stdlib.h>
+
 #include "ui_SettingsGeneral.h"
 #include "ui_SettingsPlayback.h"
 #include "ui_SettingsPlaybackModulesList.h"
@@ -124,7 +126,7 @@ void SettingsWidget::InitSettings()
 
     QMPSettings.init("AudioLanguage", QString());
     QMPSettings.init("SubtitlesLanguage", QString());
-    QMPSettings.init("screenshotPth", QStandardPaths::standardLocations(QStandardPaths::PicturesLocation).value(0, QDir::homePath()));
+    QMPSettings.init("screenshotPth", QDesktopServices::storageLocation(QDesktopServices::PicturesLocation));
 #ifdef Q_OS_WIN
     QMPSettings.init("screenshotFormat", ".bmp");
 #else
@@ -230,6 +232,31 @@ void SettingsWidget::SetAudioChannels(int chn)
     QMPlay2Core.getSettings().set("ForceChannels", forceChannels);
 }
 
+void SettingsWidget::onStoreARatioAndZoomToggled(bool checked)
+{
+    if (checked)
+    {
+        page2->keepZoom->setChecked(true);
+        page2->keepARatio->setChecked(true);
+    }
+}
+
+void SettingsWidget::onKeepZoomToggled(bool checked)
+{
+    if (!checked && !page2->keepARatio->isChecked())
+    {
+        page2->storeARatioAndZoomB->setChecked(false);
+    }
+}
+
+void SettingsWidget::onKeepARatioToggled(bool checked)
+{
+    if (!checked && !page2->keepZoom->isChecked())
+    {
+        page2->storeARatioAndZoomB->setChecked(false);
+    }
+}
+
 SettingsWidget::SettingsWidget(int page, const QString &moduleName, QWidget *videoEq) :
     videoEq(videoEq), videoEqOriginalParent(videoEq->parentWidget()),
     wasShow(false),
@@ -451,29 +478,13 @@ SettingsWidget::SettingsWidget(int page, const QString &moduleName, QWidget *vid
         page2->wheelVolumeB->setChecked(QMPSettings.getBool("WheelVolume"));
 
         page2->storeARatioAndZoomB->setChecked(QMPSettings.getBool("StoreARatioAndZoom"));
-        connect(page2->storeARatioAndZoomB, &QCheckBox::toggled, this, [this](bool checked) {
-            if (checked)
-            {
-                page2->keepZoom->setChecked(true);
-                page2->keepARatio->setChecked(true);
-            }
-        });
+        connect(page2->storeARatioAndZoomB, SIGNAL(toggled(bool)), this, SLOT(onStoreARatioAndZoomToggled(bool)));
 
         page2->keepZoom->setChecked(QMPSettings.getBool("KeepZoom"));
-        connect(page2->keepZoom, &QCheckBox::toggled, this, [this](bool checked) {
-            if (!checked && !page2->keepARatio->isChecked())
-            {
-                page2->storeARatioAndZoomB->setChecked(false);
-            }
-        });
+        connect(page2->keepZoom, SIGNAL(toggled(bool)), this, SLOT(onKeepZoomToggled(bool)));
 
         page2->keepARatio->setChecked(QMPSettings.getBool("KeepARatio"));
-        connect(page2->keepARatio, &QCheckBox::toggled, this, [this](bool checked) {
-            if (!checked && !page2->keepZoom->isChecked())
-            {
-                page2->storeARatioAndZoomB->setChecked(false);
-            }
-        });
+        connect(page2->keepARatio, SIGNAL(toggled(bool)), this, SLOT(onKeepARatioToggled(bool)));
 
         page2->showBufferedTimeOnSlider->setChecked(QMPSettings.getBool("ShowBufferedTimeOnSlider"));
         page2->savePos->setChecked(QMPSettings.getBool("SavePos"));
@@ -677,7 +688,7 @@ void SettingsWidget::applyProxy()
     Settings &QMPSettings = QMPlay2Core.getSettings();
     if (!QMPSettings.getBool("Proxy/Use"))
     {
-        qunsetenv("http_proxy");
+        unsetenv("http_proxy");
     }
     else
     {
diff --git a/src/gui/SettingsWidget.hpp b/src/gui/SettingsWidget.hpp
index b36ac00c..0047b120 100644
--- a/src/gui/SettingsWidget.hpp
+++ b/src/gui/SettingsWidget.hpp
@@ -35,7 +35,7 @@ namespace Ui {
     class ModulesList;
 }
 
-class SettingsWidget final : public QWidget
+class SettingsWidget : public QWidget
 {
     Q_OBJECT
 public:
@@ -44,7 +44,7 @@ public:
     static void SetAudioChannels(int chn);
 
     SettingsWidget(int page, const QString &module, QWidget *videoEq);
-    ~SettingsWidget();
+    ~SettingsWidget() final;
 
     void setAudioChannels();
 private:
@@ -56,8 +56,8 @@ private:
 
     inline QString getSelectedProfile();
 
-    void showEvent(QShowEvent *) override;
-    void closeEvent(QCloseEvent *) override;
+    void showEvent(QShowEvent *) override final;
+    void closeEvent(QCloseEvent *) override final;
 
     Ui::GeneralSettings *page1;
     Ui::PlaybackSettings *page2;
@@ -89,6 +89,9 @@ private slots:
     void resetSettings();
     void profileListIndexChanged(int index);
     void removeProfile();
+    void onStoreARatioAndZoomToggled(bool checked);
+    void onKeepZoomToggled(bool checked);
+    void onKeepARatioToggled(bool checked);
 signals:
     void settingsChanged(int, bool);
     void setWheelStep(int);
diff --git a/src/gui/ShortcutHandler.hpp b/src/gui/ShortcutHandler.hpp
index 1723eb78..ad140325 100644
--- a/src/gui/ShortcutHandler.hpp
+++ b/src/gui/ShortcutHandler.hpp
@@ -23,23 +23,23 @@
 
 class QAction;
 
-class ShortcutHandler final : public QAbstractTableModel
+class ShortcutHandler : public QAbstractTableModel
 {
     Q_DECLARE_TR_FUNCTIONS(ShortcutHandler)
 
 public:
     ShortcutHandler(QObject *parent);
-    ~ShortcutHandler();
+    ~ShortcutHandler() final;
 
-    int columnCount(const QModelIndex &parent) const override;
-    int rowCount(const QModelIndex &parent) const override;
+    int columnCount(const QModelIndex &parent) const override final;
+    int rowCount(const QModelIndex &parent) const override final;
 
-    Qt::ItemFlags flags(const QModelIndex &index) const override;
+    Qt::ItemFlags flags(const QModelIndex &index) const override final;
 
-    QVariant headerData(int section, Qt::Orientation orientation, int role) const override;
+    QVariant headerData(int section, Qt::Orientation orientation, int role) const override final;
 
-    QVariant data(const QModelIndex &index, int role) const override;
-    bool setData(const QModelIndex &index, const QVariant &value, int role) override;
+    QVariant data(const QModelIndex &index, int role) const override final;
+    bool setData(const QModelIndex &index, const QVariant &value, int role) override final;
 
     void appendAction(QAction *action, const QString &settingsName, const QString &defaultShortcut);
 
diff --git a/src/gui/TagEditor.cpp b/src/gui/TagEditor.cpp
index e780f555..00d82972 100644
--- a/src/gui/TagEditor.cpp
+++ b/src/gui/TagEditor.cpp
@@ -26,6 +26,11 @@
 #define TAGLIB19 (TAGLIB_VERSION >= 0x109)
 #define TAGLIB1B (TAGLIB_VERSION >= 0x10B)
 
+/* Find taglib */
+#ifndef TAGLIB_FULL_INCLUDE_PATH
+#define TAGLIB_FULL_INCLUDE_PATH
+#endif
+
 #ifdef TAGLIB_FULL_INCLUDE_PATH
     #include <taglib/taglib.h>
 #else
diff --git a/src/gui/TagEditor.hpp b/src/gui/TagEditor.hpp
index 24edcf0e..283c1497 100644
--- a/src/gui/TagEditor.hpp
+++ b/src/gui/TagEditor.hpp
@@ -29,12 +29,12 @@ class QLineEdit;
 class QSpinBox;
 class QLabel;
 
-class PictureW final : public QWidget
+class PictureW : public QWidget
 {
 public:
     PictureW(TagLib::ByteVector &picture);
 private:
-    void paintEvent(QPaintEvent *) override;
+    void paintEvent(QPaintEvent *) override final;
 
     TagLib::ByteVector &picture;
 };
@@ -44,7 +44,7 @@ class TagEditor : public QGroupBox
     Q_OBJECT
 public:
     TagEditor();
-    ~TagEditor();
+    ~TagEditor() final;
 
     bool open(const QString &fileName);
     void clear();
diff --git a/src/gui/Updater.hpp b/src/gui/Updater.hpp
index 027ce819..a18d1158 100644
--- a/src/gui/Updater.hpp
+++ b/src/gui/Updater.hpp
@@ -30,7 +30,7 @@
     class QLabel;
 #endif
 
-class Updater final : public
+class Updater : public
 #ifdef UPDATER
     QDialog
 #else
@@ -45,7 +45,7 @@ public:
 #else
     Updater(QObject *parent);
 #endif
-    ~Updater();
+    ~Updater() final;
 
 #ifdef UPDATER
     bool downloading() const;
diff --git a/src/gui/VideoAdjustmentW.cpp b/src/gui/VideoAdjustmentW.cpp
index d3f71cca..ad9d1af0 100644
--- a/src/gui/VideoAdjustmentW.cpp
+++ b/src/gui/VideoAdjustmentW.cpp
@@ -27,7 +27,7 @@
 #include <QGridLayout>
 #include <QPushButton>
 #include <QAction>
-#include <QLabel>
+#include <QVariant>
 
 enum CONTROLS
 {
@@ -69,37 +69,31 @@ VideoAdjustmentW::VideoAdjustmentW()
         slider->setRange(-100, 100);
         slider->setWheelStep(1);
         slider->setValue(0);
-        connect(slider, &Slider::valueChanged, this, [=](int v) {
-            valueL->setText(QString::number(v));
-            emit videoAdjustmentChanged(titleL->text() + QString::number(v));
-        });
+
+        connect(slider, SIGNAL(valueChanged(int)), this, SLOT(onSliderValueChanged(int)));
+
         m_sliders.push_back(slider);
 
         QAction *actionDown = new QAction(this);
-        connect(actionDown, &QAction::triggered, this, [=] {
-            slider->setValue(slider->value() - g_step);
-        });
-
         QAction *actionUp = new QAction(this);
-        connect(actionUp, &QAction::triggered, this, [=] {
-            slider->setValue(slider->value() + g_step);
-        });
+
+        connect(actionDown, SIGNAL(triggered()), this, SLOT(onActionDownTriggered()));
+        connect(actionUp, SIGNAL(triggered()), this, SLOT(onActionUpTriggered()));
 
         m_actions.push_back({actionDown, actionUp});
 
         layout->addWidget(titleL, i, 0);
         layout->addWidget(slider, i, 1);
         layout->addWidget(valueL, i, 2);
+
+        m_labelMap[slider] = std::make_pair(valueL, titleL);
     }
 
     QPushButton *resetB = new QPushButton(tr("Reset"));
-    connect(resetB, &QPushButton::clicked, this, [this] {
-        for (int i = 0; i < CONTROLS_COUNT; ++i)
-            m_sliders[i]->setValue(0);
-    });
+    connect(resetB, SIGNAL(clicked()), this, SLOT(onResetClicked()));
 
     m_resetAction = new QAction(tr("Reset video adjustments"), this);
-    connect(m_resetAction, &QAction::triggered, resetB, &QPushButton::click);
+    connect(m_resetAction, SIGNAL(triggered()), resetB, SLOT(click()));
 
     layout->addWidget(resetB, layout->rowCount(), 0, 1, 3);
     layout->addItem(new QSpacerItem(40, 0, QSizePolicy::Maximum, QSizePolicy::Minimum), layout->rowCount(), 2);
@@ -114,6 +108,7 @@ void VideoAdjustmentW::restoreValues()
     for (int i = 0; i < CONTROLS_COUNT; ++i)
         m_sliders[i]->setValue(QMPlay2Core.getSettings().getInt(QString("VideoAdjustment/") + g_controlsNames[i]));
 }
+
 void VideoAdjustmentW::saveValues()
 {
     for (int i = 0; i < CONTROLS_COUNT; ++i)
@@ -162,6 +157,7 @@ void VideoAdjustmentW::setKeyShortcuts()
 
     appendAction(m_resetAction, QString(), "reset", "0");
 }
+
 void VideoAdjustmentW::addActionsToWidget(QWidget *w)
 {
     for (int i = 0; i < CONTROLS_COUNT; ++i)
@@ -171,3 +167,45 @@ void VideoAdjustmentW::addActionsToWidget(QWidget *w)
     }
     w->addAction(m_resetAction);
 }
+
+void VideoAdjustmentW::onSliderValueChanged(int value)
+{
+    Slider *slider = qobject_cast<Slider *>(sender());
+    if (slider && m_labelMap.count(slider)) {
+        QLabel *valueL = m_labelMap[slider].first;
+        QLabel *titleL = m_labelMap[slider].second;
+        valueL->setText(QString::number(value));
+        emit videoAdjustmentChanged(titleL->text() + QString::number(value));
+    }
+}
+
+void VideoAdjustmentW::onActionDownTriggered()
+{
+    QAction *action = qobject_cast<QAction *>(sender());
+    for (size_t i = 0; i < m_actions.size(); ++i) {
+        if (m_actions[i][0] == action) { // Use array index 0 for "first"
+            Slider *slider = m_sliders[i];
+            slider->setValue(slider->value() - g_step);
+            break;
+        }
+    }
+}
+
+void VideoAdjustmentW::onActionUpTriggered()
+{
+    QAction *action = qobject_cast<QAction *>(sender());
+    for (size_t i = 0; i < m_actions.size(); ++i) {
+        if (m_actions[i][1] == action) { // Use array index 1 for "second"
+            Slider *slider = m_sliders[i];
+            slider->setValue(slider->value() + g_step);
+            break;
+        }
+    }
+}
+
+void VideoAdjustmentW::onResetClicked()
+{
+    for (int i = 0; i < CONTROLS_COUNT; ++i) {
+        m_sliders[i]->setValue(0);
+    }
+}
diff --git a/src/gui/VideoAdjustmentW.hpp b/src/gui/VideoAdjustmentW.hpp
index 419ebb01..9e9c1ece 100644
--- a/src/gui/VideoAdjustmentW.hpp
+++ b/src/gui/VideoAdjustmentW.hpp
@@ -18,22 +18,25 @@
 
 #pragma once
 
+#include <QLabel>
 #include <QWidget>
 
-#include <vector>
 #include <array>
+#include <map>
+#include <utility>
+#include <vector>
 
 class ModuleParams;
 class QAction;
 class Slider;
 
-class VideoAdjustmentW final : public QWidget
+class VideoAdjustmentW : public QWidget
 {
     Q_OBJECT
 
 public:
     VideoAdjustmentW();
-    ~VideoAdjustmentW();
+    ~VideoAdjustmentW() final;
 
     void restoreValues();
     void saveValues();
@@ -51,4 +54,11 @@ private:
     std::vector<Slider *> m_sliders;
     std::vector<std::array<QAction *, 2>> m_actions;
     QAction *m_resetAction = nullptr;
+    std::map<Slider *, std::pair<QLabel *, QLabel *>> m_labelMap;
+
+private slots:
+    void onSliderValueChanged(int value);
+    void onActionDownTriggered();
+    void onActionUpTriggered();
+    void onResetClicked();
 };
diff --git a/src/gui/VideoDock.cpp b/src/gui/VideoDock.cpp
index 74485f76..e90c5773 100644
--- a/src/gui/VideoDock.cpp
+++ b/src/gui/VideoDock.cpp
@@ -38,6 +38,12 @@
 
 constexpr int g_hideCursorTimeout = 750;
 
+void VideoDock::onDockVideo(QWidget *w)
+{
+    iDW.setWidget(w);
+    mouseMoveEvent(nullptr);
+}
+
 VideoDock::VideoDock() :
     isTouch(false), touchEnded(false),
     iDW(QMPlay2GUI.grad1, QMPlay2GUI.grad2, QMPlay2GUI.qmpTxt),
@@ -88,10 +94,7 @@ VideoDock::VideoDock() :
     connect(&iDW, SIGNAL(resized(int, int)), this, SLOT(resizedIDW(int, int)));
     connect(&iDW, SIGNAL(hasCoverImage(bool)), this, SLOT(hasCoverImage(bool)));
     connect(this, SIGNAL(visibilityChanged(bool)), this, SLOT(visibilityChanged(bool)));
-    connect(&QMPlay2Core, &QMPlay2CoreClass::dockVideo, this, [this](QWidget *w) {
-        iDW.setWidget(w);
-        mouseMoveEvent(nullptr);
-    });
+    connect(&QMPlay2Core, SIGNAL(dockVideo(QWidget *)), this, SLOT(onDockVideo(QWidget *)));
 
     if ((isBreeze = QApplication::style()->objectName() == "breeze"))
         setStyle(&commonStyle);
diff --git a/src/gui/VideoDock.hpp b/src/gui/VideoDock.hpp
index bd26b3f9..c19f4627 100644
--- a/src/gui/VideoDock.hpp
+++ b/src/gui/VideoDock.hpp
@@ -26,7 +26,7 @@
 
 class QMenu;
 
-class VideoDock final : public DockWidget
+class VideoDock : public DockWidget
 {
     Q_OBJECT
 public:
@@ -49,17 +49,17 @@ private:
 
     void unsetCursor(QWidget *w);
 
-    void dragEnterEvent(QDragEnterEvent *) override;
-    void dropEvent(QDropEvent *) override;
-    void mouseMoveEvent(QMouseEvent *) override;
-    void mouseDoubleClickEvent(QMouseEvent *) override;
-    void mousePressEvent(QMouseEvent *) override;
-    void mouseReleaseEvent(QMouseEvent *) override;
-    void moveEvent(QMoveEvent *) override;
-    void wheelEvent(QWheelEvent *) override;
-    void leaveEvent(QEvent *) override;
-    void enterEvent(QEvent *) override;
-    bool event(QEvent *) override;
+    void dragEnterEvent(QDragEnterEvent *) override final;
+    void dropEvent(QDropEvent *) override final;
+    void mouseMoveEvent(QMouseEvent *) override final;
+    void mouseDoubleClickEvent(QMouseEvent *) override final;
+    void mousePressEvent(QMouseEvent *) override final;
+    void mouseReleaseEvent(QMouseEvent *) override final;
+    void moveEvent(QMoveEvent *) override final;
+    void wheelEvent(QWheelEvent *) override final;
+    void leaveEvent(QEvent *) override final;
+    void enterEvent(QEvent *) override final;
+    bool event(QEvent *) override final;
 
     QTimer hideCursorTim, leftButtonPlayTim;
     InDockW iDW;
@@ -76,6 +76,7 @@ private slots:
     void updateImage(const QImage &);
     void visibilityChanged(bool);
     void hasCoverImage(bool);
+    void onDockVideo(QWidget *w);
 signals:
     void resized(int, int);
     void itemDropped(const QString &, bool);
diff --git a/src/gui/VideoThr.cpp b/src/gui/VideoThr.cpp
index 83c03089..85a503a8 100644
--- a/src/gui/VideoThr.cpp
+++ b/src/gui/VideoThr.cpp
@@ -181,7 +181,7 @@ void VideoThr::initFilters(bool processParams)
     {
         for (QString filterName : QMPSettings.getStringList("VideoFilters"))
         {
-            if (filterName.leftRef(1).toInt()) //if filter is enabled
+            if (filterName.left(1).toInt()) // if filter is enabled
             {
                 VideoFilter *filter = filters.on((filterName = filterName.mid(1)));
                 bool ok = false;
@@ -231,7 +231,7 @@ inline VideoWriter *VideoThr::videoWriter() const
 
 void VideoThr::run()
 {
-    bool skip = false, paused = false, oneFrame = false, useLastDelay = false, lastOSDListEmpty = true, maybeFlush = false, lastAVDesync = false, interlaced = false, err = false;
+    bool skip = false, paused = false, oneFrame = false, useLastDelay = false, lastOSDListEmpty = true, maybeFlush = false, lastAVDesync = false, interlaced = false, err = false, skipNonKey = false;
     double tmp_time = 0.0, sync_last_pts = 0.0, frame_timer = -1.0, sync_timer = 0.0, framesDisplayedTime = 0.0;
     QMutex emptyBufferMutex;
     VideoFrame videoFrame;
@@ -398,17 +398,18 @@ void VideoThr::run()
         /**/
 
         filtersMutex.lock();
-        if (playC.flushVideo)
+        if (playC.flushVideo || skipNonKey)
         {
             filters.clearBuffers();
-            frame_timer = -1.0;
+            if (playC.flushVideo)
+                frame_timer = -1.0;
         }
 
-        if (!packet.isEmpty() || maybeFlush)
+        if ((!packet.isEmpty() || maybeFlush) && (!skipNonKey || packet.hasKeyFrame))
         {
             VideoFrame decoded;
             QByteArray newPixelFormat;
-            const int bytes_consumed = dec->decodeVideo(packet, decoded, newPixelFormat, playC.flushVideo, skip ? ~0 : (fast >> 1));
+            const int bytes_consumed = dec->decodeVideo(packet, decoded, newPixelFormat, playC.flushVideo || skipNonKey, (skip && !skipNonKey) ? ~0 : (fast >> 1));
             if (!newPixelFormat.isEmpty())
                 emit playC.pixelFormatUpdate(newPixelFormat);
             if (playC.flushVideo)
@@ -437,7 +438,9 @@ void VideoThr::run()
                 gotFrameOrError = true;
             }
             else if (skip)
+            {
                 filters.removeLastFromInputBuffer();
+            }
             if (bytes_consumed < 0)
             {
                 gotFrameOrError = true;
@@ -447,6 +450,7 @@ void VideoThr::run()
             {
                 tmp_br += bytes_consumed;
             }
+            skipNonKey = false;
         }
 
         // This thread will wait for "DemuxerThr" which'll detect this error and restart with new decoder.
@@ -485,7 +489,7 @@ void VideoThr::run()
                 playC.chPos(packet.ts);
 
             double delay = packet.ts - playC.frame_last_pts;
-            if (useLastDelay || delay <= 0.0 || (playC.frame_last_pts <= 0.0 && delay > playC.frame_last_delay))
+            if (useLastDelay || delay <= 0.0 || (playC.frame_last_pts <= 0.0 && delay > playC.frame_last_delay) || (delay > 1.0 && delay / playC.frame_last_delay > 10.0))
             {
                 delay = playC.frame_last_delay;
                 useLastDelay = false;
@@ -494,11 +498,11 @@ void VideoThr::run()
             tmp_time += delay;
             ++frames;
 
-            delay /= playC.speed;
-
             playC.frame_last_delay = delay;
             playC.frame_last_pts = packet.ts;
 
+            delay /= playC.speed;
+
             if (playC.skipAudioFrame < 0.0)
                 playC.skipAudioFrame = 0.0;
 
@@ -559,6 +563,8 @@ void VideoThr::run()
                         delay = 0.0;
                         if (fast >= 7)
                             skip = true;
+                        if (fast >= 56 || (fast >= 28 && fDiff >= max_threshold * 4.0))
+                            skipNonKey = true;
                     }
                     else if (diff > 0.0) //obraz idzie za szybko
                     {
@@ -616,7 +622,7 @@ void VideoThr::run()
                 {
                     oneFrame = canWrite = false;
                     QMetaObject::invokeMethod(this, "write", Q_ARG(VideoFrame, videoFrame), Q_ARG(quint32, seq));
-                    if (canSkipFrames)
+                    if (canSkipFrames && !skipNonKey)
                         ++framesDisplayed;
                 }
                 if (canSkipFrames)
@@ -660,7 +666,7 @@ void VideoThr::screenshot(VideoFrame videoFrame)
             quint16 num = 0;
             for (const QString &f : QDir(dir).entryList({"QMPlay2_snap_?????" + ext}, QDir::Files, QDir::Name))
             {
-                const quint16 n = f.midRef(13, 5).toUShort();
+                const quint16 n = f.mid(13, 5).toUShort();
                 if (n > num)
                     num = n;
             }
diff --git a/src/gui/VideoThr.hpp b/src/gui/VideoThr.hpp
index 728edce8..6713829f 100644
--- a/src/gui/VideoThr.hpp
+++ b/src/gui/VideoThr.hpp
@@ -25,16 +25,16 @@
 class QMPlay2OSD;
 class VideoWriter;
 
-class VideoThr final : public AVThread
+class VideoThr : public AVThread
 {
     Q_OBJECT
 public:
     VideoThr(PlayClass &, VideoWriter *, const QStringList &pluginsName = {});
-    ~VideoThr();
+    ~VideoThr() final;
 
-    void stop(bool terminate = false) override;
+    void stop(bool terminate = false) override final;
 
-    bool hasDecoderError() const override;
+    bool hasDecoderError() const override final;
 
     inline VideoWriter *getHWAccelWriter() const
     {
@@ -80,7 +80,7 @@ public:
 private:
     inline VideoWriter *videoWriter() const;
 
-    void run() override;
+    void run() override final;
 
     bool deleteSubs, syncVtoA, doScreenshot, canWrite, deleteOSD, deleteFrame, gotFrameOrError, decoderError;
     double lastSampleAspectRatio;
diff --git a/src/gui/macOS/ScreenSaver.cpp b/src/gui/macOS/ScreenSaver.cpp
index 0165d5cc..d71b25b7 100644
--- a/src/gui/macOS/ScreenSaver.cpp
+++ b/src/gui/macOS/ScreenSaver.cpp
@@ -20,6 +20,10 @@
 
 #include <IOKit/pwr_mgt/IOPMLib.h>
 
+#ifdef __APPLE__
+    #include <AvailabilityMacros.h>
+#endif
+
 #define QMPLAY2_MEDIA_PLAYBACK CFSTR("QMPlay2 media playback")
 
 class ScreenSaverPriv
@@ -32,8 +36,13 @@ public:
 
     inline void inhibit()
     {
-        m_okDisp = (IOPMAssertionCreateWithName(kIOPMAssertPreventUserIdleDisplaySleep, kIOPMAssertionLevelOn, QMPLAY2_MEDIA_PLAYBACK, &m_idDisp) == kIOReturnSuccess);
-        m_okSys  = (IOPMAssertionCreateWithName(kIOPMAssertPreventUserIdleSystemSleep,  kIOPMAssertionLevelOn, QMPLAY2_MEDIA_PLAYBACK, &m_idSys)  == kIOReturnSuccess);
+#if defined(__APPLE__) && (MAC_OS_X_VERSION_MAX_ALLOWED < 1060)
+        m_okDisp = (IOPMAssertionCreate(kIOPMAssertionTypeNoDisplaySleep, kIOPMAssertionLevelOn, &m_idDisp) == kIOReturnSuccess);
+        m_okSys  = (IOPMAssertionCreate(kIOPMAssertionTypeNoIdleSleep, kIOPMAssertionLevelOn, &m_idSys)  == kIOReturnSuccess);
+#else
+        m_okDisp = (IOPMAssertionCreateWithName(kIOPMAssertionTypeNoDisplaySleep, kIOPMAssertionLevelOn, QMPLAY2_MEDIA_PLAYBACK, &m_idDisp) == kIOReturnSuccess);
+        m_okSys  = (IOPMAssertionCreateWithName(kIOPMAssertionTypeNoIdleSleep, kIOPMAssertionLevelOn, QMPLAY2_MEDIA_PLAYBACK, &m_idSys) == kIOReturnSuccess);
+#endif
     }
     inline void unInhibit()
     {
diff --git a/src/modules/AudioCD/AudioCD.hpp b/src/modules/AudioCD/AudioCD.hpp
index 95065ae0..bd19f789 100644
--- a/src/modules/AudioCD/AudioCD.hpp
+++ b/src/modules/AudioCD/AudioCD.hpp
@@ -24,19 +24,19 @@
 
 class CDIODestroyTimer;
 
-class AudioCD final : public Module
+class AudioCD : public Module
 {
     Q_OBJECT
 public:
     AudioCD();
-    ~AudioCD();
+    ~AudioCD() final;
 private:
-    QList<Info> getModulesInfo(const bool) const override;
-    void *createInstance(const QString &) override;
+    QList<Info> getModulesInfo(const bool) const override final;
+    void *createInstance(const QString &) override final;
 
-    QList<QAction *> getAddActions() override;
+    QList<QAction *> getAddActions() override final;
 
-    SettingsWidget *getSettingsWidget() override;
+    SettingsWidget *getSettingsWidget() override final;
 
     QIcon CD;
 
@@ -52,13 +52,13 @@ class QGridLayout;
 class QGroupBox;
 class QCheckBox;
 
-class ModuleSettingsWidget final : public Module::SettingsWidget
+class ModuleSettingsWidget : public Module::SettingsWidget
 {
     Q_DECLARE_TR_FUNCTIONS(ModuleSettingsWidget)
 public:
     ModuleSettingsWidget(Module &);
 private:
-    void saveSettings() override;
+    void saveSettings() override final;
 
     QGroupBox *audioCDB;
     QCheckBox *useCDDB, *useCDTEXT;
diff --git a/src/modules/AudioCD/AudioCDDemux.hpp b/src/modules/AudioCD/AudioCDDemux.hpp
index 3a0c6f3d..d98bc518 100644
--- a/src/modules/AudioCD/AudioCDDemux.hpp
+++ b/src/modules/AudioCD/AudioCDDemux.hpp
@@ -26,19 +26,19 @@
 #include <cdio/cdio.h>
 #include <cddb/cddb.h>
 
-class CDIODestroyTimer final : public QObject
+class CDIODestroyTimer : public QObject
 {
     Q_OBJECT
 public:
     CDIODestroyTimer();
-    ~CDIODestroyTimer();
+    ~CDIODestroyTimer() final;
 
     Q_SIGNAL void setInstance(CdIo_t *_cdio, const QString &_device, unsigned _discID);
     CdIo_t *getInstance(const QString &_device, unsigned &_discID);
 private slots:
     void setInstanceSlot(CdIo_t *_cdio, const QString &_device, unsigned _discID);
 private:
-    void timerEvent(QTimerEvent *e) override;
+    void timerEvent(QTimerEvent *e) override final;
 
     QAtomicInt timerId;
     CdIo_t *cdio;
@@ -48,7 +48,7 @@ private:
 
 /**/
 
-class AudioCDDemux final : public Demuxer
+class AudioCDDemux : public Demuxer
 {
     Q_DECLARE_TR_FUNCTIONS(AudioCDDemux)
 public:
@@ -56,23 +56,23 @@ public:
 
     AudioCDDemux(Module &, CDIODestroyTimer &destroyTimer);
 private:
-    ~AudioCDDemux();
+    ~AudioCDDemux() final;
 
-    bool set() override;
+    bool set() override final;
 
-    QString name() const override;
-    QString title() const override;
-    QList<QMPlay2Tag> tags() const override;
-    double length() const override;
-    int bitrate() const override;
+    QString name() const override final;
+    QString title() const override final;
+    QList<QMPlay2Tag> tags() const override final;
+    double length() const override final;
+    int bitrate() const override final;
 
-    bool seek(double, bool) override;
-    bool read(Packet &, int & ) override;
-    void abort() override;
+    bool seek(double, bool) override final;
+    bool read(Packet &, int & ) override final;
+    void abort() override final;
 
-    bool open(const QString &) override;
+    bool open(const QString &) override final;
 
-    Playlist::Entries fetchTracks(const QString &url, bool &ok) override;
+    Playlist::Entries fetchTracks(const QString &url, bool &ok) override final;
 
     /**/
 
diff --git a/src/modules/AudioFilters/AudioFilters.hpp b/src/modules/AudioFilters/AudioFilters.hpp
index 6823f625..02d3d1c1 100644
--- a/src/modules/AudioFilters/AudioFilters.hpp
+++ b/src/modules/AudioFilters/AudioFilters.hpp
@@ -20,15 +20,15 @@
 
 #include <Module.hpp>
 
-class AudioFilters final : public Module
+class AudioFilters : public Module
 {
 public:
     AudioFilters();
 private:
-    QList<Info> getModulesInfo(const bool) const override;
-    void *createInstance(const QString &) override;
+    QList<Info> getModulesInfo(const bool) const override final;
+    void *createInstance(const QString &) override final;
 
-    SettingsWidget *getSettingsWidget() override;
+    SettingsWidget *getSettingsWidget() override final;
 };
 
 /**/
@@ -41,7 +41,7 @@ class QComboBox;
 class QSpinBox;
 class Slider;
 
-class ModuleSettingsWidget final : public Module::SettingsWidget
+class ModuleSettingsWidget : public Module::SettingsWidget
 {
     Q_OBJECT
 public:
@@ -55,7 +55,7 @@ private slots:
     void compressor();
     void defaultSettings();
 private:
-    void saveSettings() override;
+    void saveSettings() override final;
 
     bool restoringDefault;
 
diff --git a/src/modules/AudioFilters/BS2B.hpp b/src/modules/AudioFilters/BS2B.hpp
index f62e4235..00822620 100644
--- a/src/modules/AudioFilters/BS2B.hpp
+++ b/src/modules/AudioFilters/BS2B.hpp
@@ -22,17 +22,17 @@
 
 #include <bs2b/bs2b.hpp>
 
-class BS2B final : public AudioFilter
+class BS2B : public AudioFilter
 {
 public:
     BS2B(Module &module);
-    ~BS2B();
+    ~BS2B() final;
 
-    bool set() override;
+    bool set() override final;
 private:
-    bool setAudioParameters(uchar, uint srate) override;
-    void clearBuffers() override;
-    double filter(Buffer &data, bool flush) override;
+    bool setAudioParameters(uchar, uint srate) override final;
+    void clearBuffers() override final;
+    double filter(Buffer &data, bool flush) override final;
 
     void alloc();
 
